Some more code additions and cleanups in bldpkg

This commit is contained in:
PktSurf 2022-07-26 10:01:17 +05:30
parent 434610595c
commit 5ae4ac2d86

99
bldpkg
View file

@ -29,8 +29,6 @@
# Exit on any error
set -e
# All variable names are to be in upper-case, function names in lower-case.
# Time when the build commenced. Note: elapsed time is logged by the runtime function way below. This output goes
# into package build summary.
commencedate="$(date '+%a, %d %b %Y, %T')"
@ -40,34 +38,25 @@ srcdir="$PWD"
# Get relative directory name from SRCDIR
srcdirpath="$(basename $srcdir)"
sourcebuildfile() {
file=$1
if [ -f "$file" ] ; then
source "$file"
elif [ -f "$srcdirpath.SMBuild" ] ; then
source "$srcdirpath.SMBuild"
else
echo "[ERROR] Could not find $srcdirpath build file to source from!"
fi
}
buildfile="$srcdirpath.SMBuild"
debugmode() {
set -ex
sourcebuildfile $1
set -x
source "$buildfile"
}
# Generate sha512sums in the build file
genchecksum() {
echo "[INFO] Discarding old sha512sums from $srcdirpath.SMBuild"
echo "[INFO] Discarding old sha512sums from $buildfile"
tempbuildfile="$buildfile"
sed -E -i \
-e '/^sha512sums=".*"$/d' \
-e '/^sha512sums="/,/"$/d' \
-e "/^sha512sums='.*'\$/d" \
"$srcdirpath".SMBuild
"$buildfile"
echo "[INFO] Adding new sha512sums in $srcdirpath.SMBuild"
printf 'sha512sums="\n' >> "$srcdirpath.SMBuild"
echo "[INFO] Adding new sha512sums in $tempbuildfile"
printf 'sha512sums="\n' >> "$tempbuildfile"
# File types
files=( *.tar.* *.zip *.t?z *.patch *.diff *.c *.h )
@ -75,13 +64,13 @@ genchecksum() {
# Checksum digest to be used along with arguments
checksumbinary="sha512sum"
for buildfile in ${files[@]} ; do
if [ -f "$buildfile" ] ; then
$checksumbinary $buildfile >> "$srcdirpath.SMBuild"
for file in ${files[@]} ; do
if [ -f "$file" ] ; then
$checksumbinary $file >> "$tempbuildfile"
fi
done
printf '"' >> "$srcdirpath.SMBuild"
printf '"' >> "$tempbuildfile"
echo "[INFO] You may now run bldpkg again"
exit 0
}
@ -90,38 +79,52 @@ help() {
cat << EOF
Bash script for building SMLinux-compatible packages from source.
This script takes only one parameter. Unmatched parameters are ignored.
This script takes only one parameter.
Usage:
-g | g | gen : Generate sha512 checksums of all tarballs and patches and put them into the package build file
-d : Invoke bash shell debug mode
-h | h | help : Show this message
-h : Show this message
-d | d | debug : Invoke bash shell debug mode
-g : Generate SHA512 checksums of all tarballs and patches and insert them into the package build file
If no arguments are provided, this script attempts to build a package provided the package build file and the parent directory name matches.
EOF
exit 0
}
if [ "$#" -gt 1 ] ; then
help
while getopts ':dhg' option; do
case "$option" in
d)
debugmode
;;
h)
help
;;
g)
genchecksum
;;
*)
help
;;
esac
done
# If no argument is given, attempt to source the build file matching the parent directory name
if [ "$OPTIND" -eq 1 ] ; then
if [ -f "$buildfile" ] ; then
source "$buildfile"
else
echo "[ERROR] Could not find $srcdirpath build file to source from!"
exit 1
fi
fi
case "$1" in
-g|g|gen)
genchecksum
;;
-h|h|help)
help
;;
-d|d|debug)
debugmode
;;
*)
sourcebuildfile $1
;;
esac
# Determine whether we are using bash version 4 and later
if [ "${BASH_VERSINFO[0]}" -lt 4 ] ; then
echo "[ERROR] You need to upgrade your bash shell to a minimum of 4.0 or higher"
exit 1
fi
# Validate the build file. If any of the following variables are not set in the build file, abort.
for buildvariables in app version build homepage desc requires ; do
@ -164,7 +167,7 @@ if [ "$(echo "$desc" | wc -c)" -gt 100 ] ; then
fi
# Check if build() function exists in the build file
if [[ ! "$(grep '^build()' "$srcdirpath".SMBuild)" ]] ; then
if [[ ! "$(grep '^build()' "$buildfile")" ]] ; then
echo "[ERROR] build() function does not exist in your build file."
exit 1
fi
@ -176,8 +179,8 @@ sleep 0.5
# Only verify source checksums if skipchecksum is not set in the build file
if [ -z "$skipchecksum" ] ; then
if [ -z "$sha512sums" ] ; then
echo "[ERROR] SHA512 checksums don't exist in $srcdirpath.SMBuild !"
echo "[ERROR] Please run 'bldpkg genchecksum' to add them"
echo "[ERROR] SHA512 checksums don't exist in $buildfile !"
echo "[ERROR] Please run 'bldpkg -g' to add them"
exit 1
fi
@ -868,7 +871,7 @@ mkfinalpkg() {
find "$pkg" ! -type d -name "*.la" -exec rm -v {} \;
# Provide a copy of the package build file so that users know the build options that went into compiling the package
install -Dm 644 "$srcdir/$app.SMBuild" "$pkgdocs/$app.SMBuild"
install -Dm 644 "$srcdir/$buildfile" "$pkgdocs/$app.SMBuild"
# Now strip the binaries and shared libraries
if [ -z "$debug" ] && [ "$debug" != "1" ]; then
@ -1260,6 +1263,8 @@ interruptoutput() {
echo ""
echo "[INFO] Caught Keyboard Interrupt"
wasinterrupted="1"
# Restore terminal colours
echo -e "$colourd"
# If installprompt and extractprompt are set and the prompt is invoked after a successful build, hitting
# ctrl-C will only set the above sm variable repeatedly and won't return user to the shell because
# of the interrupt (SIGINT) trap set way below. Putting exit 0 is a decent way to get out of that prompt